//-------------------------------
// _choose_obj_position.gsc
//-------------------------------
// create by Lion aka Florent POUJOL
// poujol.florent@wanadoo.fr
//-------------------------------
// ckeck the French mapping and scripting community for MoH and CoD series : Caskami
// http://www.caskami.com
//-------------------------------
// check instructions for installation there : http://poujol.florent.free.fr/caskami/cgp/index.html
//
// if the name of your map used for this system is different than the real name of your map don't forget to notice this name in your README.
//-------------------------------

main(mapname)
{
PreCacheModel("com_plasticcase_beige_big");
PreCacheModel("com_cellphone_on");
PreCacheModel("com_laptop_2_open");

//-----------------------------
// for Domination
dom_flaga_origin = (0, 0, 0);
dom_flagb_origin = (0, 0, 0);
dom_flagc_origin = (0, 0, 0);

//-----------------------------
// for HQ
// copy and paste one of these couple of variable to add more radio (change the number between square bracket)

level.hq_origin[1] = (0, 0, 0);
level.hq_angles[1] = (0, 0, 0);

level.hq_origin[2] = (0, 0, 0);
level.hq_angles[2] = (0, 0, 0);

level.hq_origin[3] = (0, 0, 0);
level.hq_angles[3] = (0, 0, 0);

level.hq_origin[4] = (0, 0, 0);
level.hq_angles[4] = (0, 0, 0);

//-----------------------------
// for SAB

sab_bomb_origin = (0, 0, 0);

//-----------------------------
// for SD

sd_bomb_origin = (0, 0, 0);

//-----------------------------

if( getdvar( "g_gametype" ) == "dom" ) thread dom(mapname, dom_flaga_origin, dom_flagb_origin, dom_flagc_origin);

if( getdvar( "g_gametype" ) == "koth" ) thread add_hq(mapname);

if( getdvar( "g_gametype" ) == "sab" || getdvar( "g_gametype" ) == "sd" ) thread destroyed_models();

if( getdvar( "g_gametype" ) == "sab" ) thread sab(mapname, sab_bomb_origin);

if( getdvar( "g_gametype" ) == "sd" ) thread sd(mapname, sd_bomb_origin);

}

//---------------------------------------------

dom(mapname, flaga_origin, flagb_origin, flagc_origin)
{
flag_origin[1] = flaga_origin;
flag_origin[2] = flagb_origin;
flag_origin[3] = flagc_origin;

// monitor if new coordonates had been write in the cfg
	for(i=1 ; i<=3 ; i++)
	{
		j = undefined;
		if( i == 1) j = "a";
		else if( i == 2) j = "b";
		else if( i == 3) j = "c";
		
		if( getdvar( mapname+"_dom_flag"+j ) != "" )
			flag_origin[i] = getdvarcoords( getdvar( mapname+"_dom_flag"+j ) ) ;
	}
	
//-----------------------------
	
	for(i=1 ; i<=3 ; i++)
	{
// spawn trigger_radius
		label = "";
		if(i == 1) label = "_a";
		else if(i == 2) label = "_b";
		else if(i == 3) label = "_c";
						
		flag[i] = spawn("trigger_radius", (0,0,0), i, 160, 128);
		flag[i].origin = flag_origin[i];
		flag[i].script_gameobjectname = "dom onslaught";
		flag[i].script_label = label;
		flag[i].targetname = "flag_primary";

// spawn script_origin
		j = undefined;
		k = undefined;
		switch(i)
		{
			case 1 : j = 2; k = 3; 
			break;
			case 2 : j = 1; k = 3; 
			break;
			case 3 : j = 1; k = 2; 
			break;
		}

		linkto = "";
		if( distance( flag_origin[i], flag_origin[j] ) <= 1.2*distance( flag_origin[i], flag_origin[k] ) )
			linkto = "flag"+j+" flag"+k;
		else if( closer( flag_origin[i], flag_origin[j], flag_origin[k] ) )
			linkto = "flag"+j;
		else
			linkto = "flag"+k;
		
		descriptor[i] = spawn("script_origin", flag[i].origin);
		descriptor[i].script_linkName = "flag"+i;
		descriptor[i].script_linkTo = linkto;
		descriptor[i].targetname = "flag_descriptor";
	}
}

//---------------------------------------------

add_hq(mapname)
{
	for(i=31 ; i<=50 ; i++)
	{
		j = (i - 30);
		
		if( getdvar( mapname+"_addhq"+j ) != "")
		{
			level.hq_origin[i] = getdvarcoords( getdvar( mapname+"_addhq"+j ) );
			
			if( getdvarint( mapname+"_addhq"+j+"_angle") != 0 )
				level.hq_angles[i] = (0, getdvarint(mapname+"_addhq"+j+"_angle"), 0);
			else
				level.hq_angles[i] = (0, 0, 0);			
		}
	}
	
thread remove_hq(mapname);
}

remove_hq(mapname)
{
	for(i=1 ; i<=50 ; i++)
	{
		if( getdvar(mapname+"_deletehq"+i) != "" )
		{
			delete_origin = getdvarcoords( getdvar(mapname+"_deletehq"+i) );
			
			for(j=1 ; j<=level.hq_origin.size ; j++)
			{
				if( distance2d( delete_origin , level.hq_origin[j] ) <= 100 )
					level.hq_origin[j] = (0, 0, 0);
			}
		}
	}

thread koth(mapname);
}

koth(mapname)
{
hq_clips = getentarray("koth_clip","targetname");

	for(i=1 ; i<=50 ; i++)
	{
		if( isdefined( level.hq_origin[i] ) && level.hq_origin[i] != (0, 0, 0) )
		{
			if( !isdefined( level.hq_angles[i] ) )
				level.hq_angles[i] = (0, 0, 0);
			
			// spawn trigger_radius
			trig[i] = spawn("trigger_radius", level.hq_origin[i] - (0,0,10), 4, 100, 128);
			trig[i].targetname = "radiotrigger";
			
			// spawn plastic case
			plasticcase[i] = spawn("script_model", level.hq_origin[i], 4);
			plasticcase[i] setmodel("com_plasticcase_beige_big");
			plasticcase[i].script_gameobjectname = "hq";
			plasticcase[i].targetname = "laptop_target"+i;
			plasticcase[i].angles = (0, 0, 0);
			
			// spawn cellphone
			cellphone[i] = spawn("script_model", plasticcase[i].origin + (18.7, -8.7, 30), 4);
			cellphone[i] setmodel("com_cellphone_on");
			cellphone[i].script_gameobjectname = "hq";
			cellphone[i].targetname = "laptop_target"+i;
			cellphone[i].angles = (0, 40, -90);		
			
			// spawn laptop
			laptop[i] = spawn("script_model", plasticcase[i].origin + (4, -4, 30), 4);
			laptop[i] setmodel("com_laptop_2_open");
			laptop[i].script_gameobjectname = "hq";
			laptop[i].targetname = "hq_hardpoint";
			laptop[i].target = "laptop_target"+i;
			laptop[i].angles = (0, 270, 0);
			
			// move clips
			if( isdefined( hq_clips[i] ) )
			{
				hq_clips[i].origin = plasticcase[i].origin;
				hq_clips[i].targetname = "laptop_target"+i;
				hq_clips[i] linkto( plasticcase[i] );
			}
			
			cellphone[i] linkto( plasticcase[i] );
			laptop[i] linkto( plasticcase[i] );
			plasticcase[i].angles = level.hq_angles[i];
		}
	}
}

//---------------------------------------------

destroyed_models()
{
destroyed_models = getentarray("exploder", "targetname");

trig_plant_allies = getent("sab_bomb_allies", "targetname");
trig_plant_axis = getent("sab_bomb_axis", "targetname");

sd_trig_plant = getentarray("bombzone", "targetname");


	for( i=0 ; i<destroyed_models.size ; i++ )
	{
		if( isdefined( trig_plant_allies ) && isdefined( trig_plant_axis ) )
		{
			if( distance( destroyed_models[i].origin , trig_plant_allies.origin ) <= 50 )
				level.sab_allies_destroyed_model = destroyed_models[i];
			
			if( distance( destroyed_models[i].origin , trig_plant_axis.origin ) <= 50 )
				level.sab_axis_destroyed_model = destroyed_models[i];
		}
		
		if( isdefined( sd_trig_plant ) )
		{
			if( distance( destroyed_models[i].origin , sd_trig_plant[0].origin ) <= 50 )
				level.sd_a_destroyed_model = destroyed_models[i];

			if( distance( destroyed_models[i].origin , sd_trig_plant[1].origin ) <= 50 )
				level.sd_b_destroyed_model = destroyed_models[i];
		}
	}
}

sab(mapname, bomb_origin)
{
trig_plant_allies = getent("sab_bomb_allies", "targetname");
trig_plant_axis = getent("sab_bomb_axis", "targetname");

clips = getentarray("script_brushmodel","classname");

	for(i=0 ; i<clips.size ; i++)
	{
		if( clips[i].script_gameobjectname == "sab" )
		{
			if( distance( clips[i].origin , trig_plant_allies.origin ) <= 50 )
				level.allies_clip = clips[i];
			
			if( distance( clips[i].origin , trig_plant_axis.origin ) <= 50 )
				level.axis_clip = clips[i];
		}
	}

//-----------------------------
	
	if( getdvar( mapname+"_sab_obj_allies" ) != "" )
	{
		obj_allies_origin = getdvarcoords( getdvar( mapname+"_sab_obj_allies" ) );
		
		//move the trigger_touch to plant the bomb to the new origin
		trig_plant_allies.origin = obj_allies_origin;

		// move the destroyed model
		level.sab_allies_destroyed_model.origin = obj_allies_origin;
		
		//move the entire model
		allies_obj_entire = getent(trig_plant_allies.target , "targetname" );
		allies_obj_entire.origin = obj_allies_origin;
		
		// move brushmodel
		level.allies_clip.origin = obj_allies_origin;
	}
	
//-----------------------------

	if( getdvar( mapname+"_sab_obj_axis" ) != "" )
	{
		obj_axis_origin = getdvarcoords( getdvar( mapname+"_sab_obj_axis" ) );
		
		// move the trigger_touch to plant the bomb to the new origin
		trig_plant_axis.origin = obj_axis_origin;

		// move the destroyed model
		level.sab_axis_destroyed_model.origin = obj_axis_origin;
		
		//move the entire model
		axis_obj_entire = getent(trig_plant_axis.target , "targetname" );
		axis_obj_entire.origin = obj_axis_origin;
		
		// move brushmodel
		level.axis_clip.origin = obj_axis_origin;
	}
	
//-----------------------------
// spawn the bomb on the map

	if( getdvar( mapname+"_sab_bomd" ) != "" )
		bomb_origin = getdvarcoords( getdvar( mapname+"_sab_bomd" ) );

	trig = spawn("trigger_radius", bomb_origin, 1, 32, 50);
	trig.script_gameobjectname = "sab";
	trig.targetname = "sab_bomb_pickup_trig";

	bomb = spawn("script_model", trig.origin + (0, 0, 10), 4);
	bomb.script_gameobjectname = "sab";
	bomb.targetname = "sab_bomb";
}

//---------------------------------------------

sd(mapname, bomb_origin)
{
trig_plant = getentarray("bombzone", "targetname");
destroyed_models = getentarray("exploder", "targetname") ;

clips = getentarray("script_brushmodel","classname");

	for(i=0 ; i<clips.size ; i++)
	{
		if( clips[i].script_gameobjectname == "bombzone" )
		{
			if( distance( clips[i].origin , trig_plant[0].origin ) <= 50 )
				level.obja_clip = clips[i];
			
			if( distance( clips[i].origin , trig_plant[1].origin ) <= 50 )
				level.objb_clip = clips[i];
		}
	}
	
//-----------------------------	
	
	if( getdvar( mapname+"_sd_obj_a" ) != "" )
	{
		obj_a_origin = getdvarcoords( getdvar( mapname+"_sd_obj_a" ) );
		
		// move the trigger_touch to plant the bomb to the new origin
		trig_plant[0].origin = obj_a_origin;

		// move the destroyed model
		level.sd_a_destroyed_model.origin = obj_a_origin;
		
		//move the entire model
		a_obj_entire = getent(trig_plant[0].target , "targetname" );
		a_obj_entire.origin = obj_a_origin;
		
		// move brushmodel
		level.obja_clip.origin = obj_a_origin;
	}
	
//-----------------------------

	if( getdvar( mapname+"_sd_obj_b" ) != "" )
	{
		obj_b_origin = getdvarcoords( getdvar( mapname+"_sd_obj_b" ) );
		
		// move the trigger_touch to plant the bomb to the new origin
		trig_plant[1].origin = obj_b_origin;

		// move the destroyed model
		level.sd_b_destroyed_model.origin = obj_b_origin;
		
		//move the entire model
		b_obj_entire = getent(trig_plant[1].target , "targetname" );
		b_obj_entire.origin = obj_b_origin;
		
		// move brushmodel
		level.objb_clip.origin = obj_b_origin;
	}
	
//-----------------------------
// spawn the bomb on the map

	if( getdvar( mapname+"_sd_bomd" ) != "" )
		bomb_origin = getdvarcoords( getdvar( mapname+"_sd_bomd" ) );

	trig = spawn("trigger_radius", bomb_origin, 1, 32, 50);
	trig.script_gameobjectname = "sd";
	trig.targetname = "sd_bomb_pickup_trig";

	bomb = spawn("script_model", trig.origin + (0, 0, 10), 4);
	bomb.script_gameobjectname = "sd";
	bomb.targetname = "sd_bomb";
}

//---------------------------------------------

GetDvarCoords( dvar )
{
array = StrTok(dvar, "_");

coords = ( StringToInt(array[0]), StringToInt(array[1]), StringToInt(array[2])-60 );

return coords;
}

StringToInt( string )
{
	for( i=(-10000) ; i<=10000 ; i++ )
	{
		if( ""+i+"" == string )
			return i;
	}
}
